function [loaded_data] = ANA_NMR_load_disre_log_model(file_path, restr_number)
%% Interpret the content of disre.log from Gromacs' nmr refinement routine g_disre
% clc;
% clear all;
%% Opening the file
% filename = 'D:\02_EnHD\MD_simulations_EnHD\_AMBER_100ns_2JWT\disre_pdb_central10\275_0.06_10_065820_.log';
if exist(file_path) == 2
   s = dir(file_path);
   filesize = s.bytes;
   if filesize < 5000
      display('W:! Something wrong with distance restrain');
      display('    calculations, log-file is less than 5Kb.');
      display('    Try to check if you have the correct file.');
      display('    To allow smaller files to be analysed, please');
      display('    change the corresponding line in the script');
      display('    ANA_NMR_load_disre_log_model.m , line #9-11.');
      display(file_path);
      loaded_data = [];
   else
  fileID = fopen(file_path,'r');
%% reading routine
  tline = fgetl(fileID);
  start_reading_flag = 0;
  text_data = [];
  counted_violation = 0;
  while ~feof(fileID)
    tline = fgetl(fileID);
    if strcmp(tline,'++++++++++++++ STATISTICS ++++++++++++++++++++++++') == 1 
      tline = fgetl(fileID);
      tline = fgetl(fileID);    
      start_reading_flag = 1;
    end
    if strcmp(tline,'') == 1 
      start_reading_flag = 0;
    end
        if start_reading_flag == 1
%       for ii=1:length(tline-1)
%          if tline(ii:ii+1) == 'no'
          tline1 = [tline(1:9) tline(13:end)]; 
          counted_violation = str2num(tline(1:9));
%           counted_violation
%           text_data
%           tline1
          text_data = [text_data; tline1];
        end
    if counted_violation >= restr_number
       start_reading_flag = 0;
    end
  end
  fclose(fileID);
  loaded_data = str2num(text_data);
  loaded_data = sortrows(loaded_data, 1);
% loaded_data = [Restr. Up1  <r> <rT3> <rT6> <viol> <violT3> <violT6>];

% plot(loaded_data(:,1),loaded_data(:,6),'x');
% sum(loaded_data(:,6));
   end
else
    display('check if the file exists:');
    display(file_path);
end
end