function [chromosomes_child_num] = GA_CORE_Crossing(number_of_chromosomes, number_of_species, number_of_xrs_spectra, chromosomes_num_end)
%% Applies a crossing operator to the ensemble of chromosomes
for ii = 1:number_of_chromosomes
  % parent 1:      
       random_val = round(random('unif',1,number_of_chromosomes));
       if random_val>number_of_xrs_spectra
          random_val = number_of_xrs_spectra+1;
       end
       chromosomes_child_num(ii,:) = chromosomes_num_end(1,random_val,:);
  % parent 2:    
       random_val = round(random('unif',1,number_of_chromosomes));
       if random_val>number_of_xrs_spectra
          random_val = number_of_xrs_spectra+1;
       end
       parent2_num = chromosomes_num_end(1,random_val,:); 
  % parents crossing:     
       crossingpoint = round(random('unif',1,number_of_species));
       chromosomes_child_num(ii,crossingpoint:end) = parent2_num(crossingpoint:end);
       chromosomes_child_num(ii,:) = sort(chromosomes_child_num(ii,:));    
end

end