function [chromosomes_mutants_num encountering_matrix] = GA_CORE_Mutation(number_of_chromosomes, number_of_species, number_of_xrs_spectra, number_of_spectra_total, chromosomes_num_end,encountering_matrix,mutation_multiplyer)
%% Applies mutation operator to the current population
chromosomes_mutants_num = [];
for hh = 1:mutation_multiplyer
   chromosomes_mutants_num = [chromosomes_mutants_num; squeeze(chromosomes_num_end(1,:,:))];
end
for ii = 1:number_of_chromosomes*mutation_multiplyer
          rand_val = random('unif',0.5,1);
          mutation_matrix = round(random('unif',0,rand_val,[number_of_species,1]));
       for jj = 1:number_of_species     
          if mutation_matrix(jj)==1  
%             random_val = round(random('unif',1,number_of_spectra_total));
             random_val = unidrnd(number_of_spectra_total,1,1); % unidrnd(a,x,y) - generates matrix x by y filled with randoms 1..a
            if random_val>number_of_xrs_spectra
              random_val = number_of_xrs_spectra+1;
            end
            chromosomes_mutants_num(ii,jj) = random_val;
            encountering_matrix(random_val,1) = 1+encountering_matrix(random_val,1);
          end 
       end
      chromosomes_mutants_num(ii,:) = sort(chromosomes_mutants_num(ii,:)); 
end
end