function [fig_handle1,fig_handle2] = GA_plot_Best_objectives_solution(q_theory,chromosomes_last_step, q_data,data_exp, X_matrix, chi_evaluation_matrix, savefolder_run,nmr_power_averaging, fitting_mode)
%% Plots the best solution for each objective obtained in GA
%% Optimal XRS solution
background = 100;
fig_handle1 = figure(111001);
% chi_evaluation_matrix(1,1)
objective_no = 1;
hold on
fig_handle1 = subplot(4,1,1:3);
optimal_xrs = interp1(q_theory,background*X_matrix(end,objective_no,2)+(X_matrix(end,objective_no,1)*mean(squeeze(chromosomes_last_step(:,objective_no,:)),2)),q_data);
if fitting_mode=='LIN'
semilogy(q_data,data_exp,...
         q_data,optimal_xrs,...
              'LineWidth',2);
elseif fitting_mode=='LOG'
plot(q_data,data_exp,...
         q_data,optimal_xrs,...
              'LineWidth',2);
end    
set(subplot(4,1,1:3),...
         'YLim',[min(data_exp)/1.5 1.5*max(data_exp)]);
          ylabel('Log I');
  title(['chi = ',num2str(chi_evaluation_matrix(2,objective_no)),...
         ',  Viol = ',num2str(chi_evaluation_matrix(3,objective_no))],'FontSize',16);

subplot(4,1,4);     
difference_xrs = data_exp-...
    interp1(q_theory,X_matrix(end,objective_no,2)+(X_matrix(end,objective_no,1)*mean(squeeze(chromosomes_last_step(:,objective_no,:)),2)),q_data);
plot(q_data,difference_xrs,...
              'LineWidth',2);
          xlabel('q, A^{-1}'); 
  hold off
 saveas(gcf,[savefolder_run 'Figures\dominated_chi_solution.png']);
 saveas(gcf,[savefolder_run 'Figures\dominated_chi_solution.fig']);
%% optimal NMR solution
fig_handle2 = figure(111002);
objective_no = 2;
subplot(4,1,1:3);
optimal_nmr = interp1(q_theory,X_matrix(end,objective_no,2)+(X_matrix(end,objective_no,1)*mean(squeeze(chromosomes_last_step(:,objective_no,:)),2)),q_data);
semilogy(q_data,data_exp,...
         q_data,optimal_nmr,...
              'LineWidth',2);
set(subplot(4,1,1:3),...
         'YLim',[min(data_exp)/1.5 1.5*max(data_exp)]);
          ylabel('Log I');
  title(['chi = ',num2str(chi_evaluation_matrix(2,objective_no)),...
         ',  Viol = ',num2str(chi_evaluation_matrix(3,objective_no))],'FontSize',16);
subplot(4,1,4);    
difference_nmr = data_exp-...
    interp1(q_theory,X_matrix(end,objective_no,2)+(X_matrix(end,objective_no,1)*mean(squeeze(chromosomes_last_step(:,objective_no,:)),2)),q_data);
plot(q_data,difference_nmr,...
              'LineWidth',2);
          xlabel('q, A^{-1}'); 
 saveas(gcf,[savefolder_run 'Figures\dominated_nmr_solution.png']);
 saveas(gcf,[savefolder_run 'Figures\dominated_nmr_solution.fig']);
%% optimal NMR & XRS solution on the same plot
fig_handle2 = figure(111002);
if nmr_power_averaging ~= 0
objective_no = 2;
subplot(4,1,1:3);
semilogy(q_data,data_exp,'r',...
         q_data,optimal_xrs,'b',...
         q_data,optimal_nmr,'g',...
         'LineWidth',2);
 legend('Experimental XRS','Optimized to fit XRS','Optimized to fit NMR');     
set(subplot(4,1,1:3),...
         'YLim',[min(data_exp)/1.5 1.5*max(data_exp)]);
          ylabel('Log I');
  title(['chi = ',num2str(chi_evaluation_matrix(2,objective_no)),...
         ',  Viol = ',num2str(chi_evaluation_matrix(3,objective_no))],'FontSize',16);
subplot(4,1,4);       
plot(q_data,difference_xrs,'b',...
     q_data,difference_nmr,'g',...
              'LineWidth',2);
 legend('chi_{XRS}','chi_{NMR}'); 
          xlabel('q, A^{-1}'); 
 saveas(gcf,[savefolder_run 'Figures\dominated_nmr_and_xrs_solution.png']);
 saveas(gcf,[savefolder_run 'Figures\dominated_nmr_and_xrs_solution.fig']);
else
objective_no = 1;
subplot(4,1,1:3);
semilogy(q_data,data_exp,'r',...
         q_data,optimal_xrs,'b',...
         'LineWidth',2);
 legend('Experimental XRS','Optimized to fit XRS');     
set(subplot(4,1,1:3),...
         'YLim',[min(data_exp)/1.5 1.5*max(data_exp)]);
          ylabel('Log I');
  title(['chi = ',num2str(chi_evaluation_matrix(2,objective_no)),...
         ',  Viol = ',num2str(chi_evaluation_matrix(3,objective_no))],'FontSize',16);
subplot(4,1,4);       
plot(q_data,difference_xrs,'b',...
              'LineWidth',2);
 legend('chi_{XRS}'); 
          xlabel('q, A^{-1}'); 
 saveas(gcf,[savefolder_run 'Figures\dominated_xrs_solution.png']);
 saveas(gcf,[savefolder_run 'Figures\dominated_xrs_solution.fig']);   

%% LOGGING THE DATA
data_log_dir = [savefolder_run, 'data_log\'];
if exist(data_log_dir,'dir')==0
    mkdir(data_log_dir);
end
% save([data_log_dir,'optimal_xrs.txt'], 'q_data', 'optimal_xrs', 'difference_xrs', '-ASCII') ;
log_xrs = [q_data, data_exp, optimal_xrs, difference_xrs];
save([data_log_dir,'optimal_xrs.txt'], 'log_xrs', '-ASCII') ;
log_nmr = [q_data, data_exp, optimal_nmr, difference_nmr];
save([data_log_dir,'optimal_nmr.txt'], 'log_nmr', '-ASCII') ;

end
